com.fasterxml.jackson.databind.exc

## Class InvalidDefinitionException

- java.lang.Object
- - java.lang.Throwable
  - - java.lang.Exception
    - - java.io.IOException
      - - com.fasterxml.jackson.core.JacksonException
        - - com.fasterxml.jackson.core.JsonProcessingException
          - - com.fasterxml.jackson.databind.DatabindException
            - - com.fasterxml.jackson.databind.JsonMappingException
              - - com.fasterxml.jackson.databind.exc.InvalidDefinitionException

All Implemented Interfaces:
  Serializable

    public class InvalidDefinitionException
    extends JsonMappingException

Intermediate exception type used as the base class for all `JsonMappingException`s that are due to problems with target type definition; usually a problem with annotations used on a class or its properties. This is in contrast to `MismatchedInputException` which signals a problem with input to map.

Since:
  2.9
See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonMappingException

`JsonMappingException.Reference`

### Field Summary

Fields
`protected BeanDescription` `_beanDesc`
`protected BeanPropertyDefinition` `_property`
`protected JavaType` `_type`

### Fields inherited from class com.fasterxml.jackson.databind.JsonMappingException

`_path, _processor`

### Fields inherited from class com.fasterxml.jackson.core.JsonProcessingException

`_location`

### Constructor Summary

Constructors
`protected` `InvalidDefinitionException(com.fasterxml.jackson.core.JsonGenerator g, String msg, BeanDescription bean, BeanPropertyDefinition prop)`
`protected` `InvalidDefinitionException(com.fasterxml.jackson.core.JsonGenerator g, String msg, JavaType type)`
`protected` `InvalidDefinitionException(com.fasterxml.jackson.core.JsonParser p, String msg, BeanDescription bean, BeanPropertyDefinition prop)`
`protected` `InvalidDefinitionException(com.fasterxml.jackson.core.JsonParser p, String msg, JavaType type)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static InvalidDefinitionException` `from(com.fasterxml.jackson.core.JsonGenerator g, String msg, BeanDescription bean, BeanPropertyDefinition prop)`
`static InvalidDefinitionException` `from(com.fasterxml.jackson.core.JsonGenerator g, String msg, JavaType type)`
`static InvalidDefinitionException` `from(com.fasterxml.jackson.core.JsonParser p, String msg, BeanDescription bean, BeanPropertyDefinition prop)`
`static InvalidDefinitionException` `from(com.fasterxml.jackson.core.JsonParser p, String msg, JavaType type)`
`BeanDescription` `getBeanDescription()` Accessor for type definition (class) that had the definition problem, if any; may sometimes be undefined or unknown; if so, returns `null`.
`BeanPropertyDefinition` `getProperty()` Accessor for property that had the definition problem if any (none, for example if the problem relates to type in general), if known.
`JavaType` `getType()` Accessor for type fully resolved type that had the problem; this should always known and available, never `null`

### Methods inherited from class com.fasterxml.jackson.databind.JsonMappingException

`_appendPathDesc, _appendReferenceChain, _buildMessage, from, from, from, from, from, from, from, from, fromUnexpectedIOE, getLocalizedMessage, getMessage, getPath, getPathReference, getPathReference, getProcessor, prependPath, prependPath, prependPath, toString, withCause, wrapWithPath, wrapWithPath, wrapWithPath`

### Methods inherited from class com.fasterxml.jackson.core.JsonProcessingException

`clearLocation, getLocation, getMessageSuffix, getOriginalMessage`

### Methods inherited from class java.lang.Throwable

`addSuppressed, fillInStackTrace, getCause, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### _type

    protected final JavaType _type

#### _beanDesc

    protected transient BeanDescription _beanDesc

#### _property

    protected transient BeanPropertyDefinition _property

### Constructor Detail

#### InvalidDefinitionException

    protected InvalidDefinitionException(com.fasterxml.jackson.core.JsonParser p,
                                         String msg,
                                         JavaType type)

#### InvalidDefinitionException

    protected InvalidDefinitionException(com.fasterxml.jackson.core.JsonGenerator g,
                                         String msg,
                                         JavaType type)

#### InvalidDefinitionException

    protected InvalidDefinitionException(com.fasterxml.jackson.core.JsonParser p,
                                         String msg,
                                         BeanDescription bean,
                                         BeanPropertyDefinition prop)

#### InvalidDefinitionException

    protected InvalidDefinitionException(com.fasterxml.jackson.core.JsonGenerator g,
                                         String msg,
                                         BeanDescription bean,
                                         BeanPropertyDefinition prop)

### Method Detail

#### from

    public static InvalidDefinitionException from(com.fasterxml.jackson.core.JsonParser p,
                                                  String msg,
                                                  BeanDescription bean,
                                                  BeanPropertyDefinition prop)

#### from

    public static InvalidDefinitionException from(com.fasterxml.jackson.core.JsonParser p,
                                                  String msg,
                                                  JavaType type)

#### from

    public static InvalidDefinitionException from(com.fasterxml.jackson.core.JsonGenerator g,
                                                  String msg,
                                                  BeanDescription bean,
                                                  BeanPropertyDefinition prop)

#### from

    public static InvalidDefinitionException from(com.fasterxml.jackson.core.JsonGenerator g,
                                                  String msg,
                                                  JavaType type)

#### getType

    public JavaType getType()

Accessor for type fully resolved type that had the problem; this should always known and available, never `null`

#### getBeanDescription

    public BeanDescription getBeanDescription()

Accessor for type definition (class) that had the definition problem, if any; may sometimes be undefined or unknown; if so, returns `null`.

#### getProperty

    public BeanPropertyDefinition getProperty()

Accessor for property that had the definition problem if any (none, for example if the problem relates to type in general), if known. If not known (or relevant), returns `null`.